SystemOrganization addCategory: #Kozen!

!String methodsFor: '*kozen' stamp: 'StephaneDucasse 1/6/2012 15:31'!
deDoubleSingleQuotes
	"transform two subsequent single quotes into one"
	
	"'abcdebcdg' . 'bc' .'z' ->  'azdezdg' but the same with '' and '"
	
	^ self copyReplaceAll: (String with: $' with: $')  with: (String with: $') 
	! !

Object subclass: #ARTodo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARTodo commentStamp: 'sd 1/7/2012 16:30' prior: 0!
to do
	- add long cv link
	- manage lists
	- convert all web site
	- manage news: show two from a list and on demand all
	- parse information from file instead of typing it in Smalltalk
	!

Object subclass: #Citeseer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!Citeseer commentStamp: 'DamienCassou 1/6/2012 18:39' prior: 0!
Get the rank of someone in the Citeseer author's citation ranking (http://citeseerx.ist.psu.edu/stats/authors?all=true).

For example:

Citeseer rankOf: 'S. Ducasse'!

!Citeseer class methodsFor: 'public' stamp: 'DamienCassou 1/6/2012 18:37'!
rankOf: aName
	"self rankOf: 'S. Ducasse'"
	^ self new rankOf: aName! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:23'!
getCiteseerPage
	^ ZnHttpClient new
		url: 'http://citeseerx.ist.psu.edu/stats/authors';
		parameterAt: 'all' put: 'true';
		get! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:36'!
getRankFrom: page stoppingAt: aString
	| count |
	count := 0.
	page
		regex: '<li>[[:space:]]*<span class="authors">[^>]+>([^<]+)'
		matchesDo: [:match | (match matchesRegex: ('.*', aString, '$'))
								ifTrue: [^ count + 1]
								ifFalse: [count := count + 1]].
	^ Error signal: aString, ' not found in page'! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:34'!
rankOf: aName
	| content rank |
	content := self getCiteseerPage.
	rank := self getRankFrom: content stoppingAt: aName.
	^ rank ! !

Object subclass: #KZObject
	instanceVariableNames: 'value siteId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

KZObject subclass: #KZImage
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZImage methodsFor: 'visiting' stamp: 'StephaneDucasse 1/3/2012 11:20'!
accept: aVisitor

	aVisitor visitImage: self.
! !

!KZImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:17'!
image
	^ image! !

!KZImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:17'!
image: anObject
	image := anObject! !

KZImage subclass: #KZLinkedImage
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZLinkedImage methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:51'!
accept: aVisitor

	aVisitor visitLinkedImage: self! !

!KZLinkedImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:51'!
link
	^ link! !

!KZLinkedImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:51'!
link: anObject
	link := anObject! !

KZObject subclass: #KZItem
	instanceVariableNames: 'name link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

KZItem subclass: #KZBlockItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZBlockItem commentStamp: 'StephaneDucasse 1/3/2012 23:00' prior: 0!
ARBlockItem is an item of a floating block. For example like on the right of my web page.!

!KZBlockItem methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 23:04'!
accept: aVisitor

	aVisitor visitRightBlockItem: self.
! !

!KZItem methodsFor: 'visit' stamp: 'sd 1/8/2012 22:15'!
accept: aVisitor

	aVisitor visitItem: self.! !

!KZItem methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:59'!
link
	
	^ link! !

!KZItem methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:59'!
link: aName

	link := aName! !

!KZItem methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:59'!
name

	^ name! !

!KZItem methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:59'!
name:  aString

	name := aString! !

KZItem subclass: #KZMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZMenuItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/2/2012 22:57'!
accept: aVisitor

	aVisitor visitMenuItem: self.
! !

KZObject subclass: #KZList
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

KZList subclass: #KZDivBlock
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZDivBlock commentStamp: 'StephaneDucasse 1/5/2012 22:15' prior: 0!
<div id="header">
	attribute = id 
	value = header
	
	and nested components
	
!

!KZDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 11:19'!
accept: aVisitor

	aVisitor visitDivBlock: self.
! !

!KZDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:11'!
attribute
	^ attribute! !

!KZDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:11'!
attribute: aString
	
	attribute := aString! !

!KZList methodsFor: 'visit' stamp: 'sd 1/8/2012 22:30'!
accept: aVisitor

	aVisitor visitItemList: self! !

!KZList methodsFor: 'elements' stamp: 'StephaneDucasse 1/3/2012 22:47'!
addElement: anElement

	elements add: anElement! !

!KZList methodsFor: 'elements' stamp: 'StephaneDucasse 1/3/2012 22:47'!
elements

	^ elements! !

!KZList methodsFor: 'initialize' stamp: 'StephaneDucasse 1/3/2012 22:46'!
initialize

	super initialize.
	elements := OrderedCollection new.! !

KZList subclass: #KZMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZMenu methodsFor: 'visit' stamp: 'StephaneDucasse 1/2/2012 22:56'!
accept: aVisitor

	aVisitor visitMenu: self.
! !

KZList subclass: #KZResearchTopic
	instanceVariableNames: 'text bibItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

KZList subclass: #KZRightBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZRightBlock methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:49'!
accept: aVisitor

	aVisitor visitRightBlock: self.! !

KZList subclass: #KZSection
	instanceVariableNames: 'levelNumber title text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:18'!
accept: aVisitor

	aVisitor visitSection: self! !

!KZSection methodsFor: 'initialize' stamp: 'sd 1/7/2012 20:53'!
initialize

	super initialize.
	levelNumber := '2'.! !

!KZSection methodsFor: 'accessing' stamp: 'sd 1/7/2012 20:53'!
levelDigitString

	^ levelNumber! !

!KZSection methodsFor: 'accessing' stamp: 'sd 1/7/2012 20:59'!
levelDigitString: aString
	"'2' for h2, '3' for h3...."

	levelNumber := aString! !

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
text
	^ text! !

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
text: anObject
	text := anObject! !

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
title
	^ title! !

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
title: anObject
	title := anObject! !

!KZObject methodsFor: 'visiting' stamp: 'StephaneDucasse 1/2/2012 22:47'!
accept: aVisitor
	! !

!KZObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 09:57'!
siteId
	^ siteId! !

!KZObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 09:57'!
siteId: anId
	"anId should uniquely identify the receiver"
	siteId := anId! !

!KZObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:09'!
value
	^ value! !

!KZObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:10'!
value: aString
	value := aString! !

KZObject subclass: #KZPage
	instanceVariableNames: 'title elements head name main site filename cssFile headerSiteTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZPage commentStamp: 'StephaneDucasse 1/18/2012 21:24' prior: 0!
I'm a page and as such I contain elements and I'm saved in a file.!

!KZPage class methodsFor: 'instance creation' stamp: 'StephaneDucasse 1/24/2012 09:08'!
name: aString filename: aFileName

	^ self new name: aString; filename: aFileName; yourself! !

!KZPage methodsFor: 'visiting' stamp: 'StephaneDucasse 1/2/2012 22:57'!
accept: aVisitor

	aVisitor visitPage: self.
! !

!KZPage methodsFor: 'adding' stamp: 'StephaneDucasse 1/2/2012 21:54'!
addElement: anElement

	elements add: anElement.! !

!KZPage methodsFor: 'adding' stamp: 'StephaneDucasse 1/6/2012 14:34'!
addElementInMain: anElement

	main addElement: anElement.! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:49'!
cssFile
	^cssFile! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:49'!
cssFile: aString
	
	cssFile := aString! !

!KZPage methodsFor: 'default' stamp: 'StephaneDucasse 1/19/2012 21:41'!
defaultCSSFile
	^ 'CSS/stef.css'! !

!KZPage methodsFor: 'default' stamp: 'StephaneDucasse 1/2/2012 22:39'!
defaultName

	^ 'Home'! !

!KZPage methodsFor: 'default' stamp: 'StephaneDucasse 1/19/2012 21:55'!
defaultTitle

	^ 'The title can also give some information about you' ! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:54'!
elements

	^ elements! !

!KZPage methodsFor: 'accessing' stamp: 'sd 1/8/2012 21:29'!
filename
	
	|fn|
	filename isNil 
		ifTrue: [fn := name]
		ifFalse: [fn := filename].
	^ fn, '.html'.
	! !

!KZPage methodsFor: 'accessing' stamp: 'sd 1/8/2012 21:24'!
filename: aName
	
	filename := aName! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 2/5/2012 16:22'!
head

	^ '<head>
		<link rel="stylesheet" href="' , self cssFile
		,
			'"/>
		<title>' , self defaultTitle
		,
			'</title>
   </head>'! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:26'!
headerPageTitle

	^ self name
! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:58'!
headerSiteTitle
	"the title inside the page"
	
	^ headerSiteTitle! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:58'!
headerSiteTitle: aString
	"the title inside the page"
	
	headerSiteTitle := aString! !

!KZPage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 1/19/2012 21:54'!
initialize

	super initialize.
	elements := OrderedCollection new.
	title := self defaultTitle.
	name := self defaultName.
	cssFile := self defaultCSSFile.
	main := KZDivBlock new attribute: 'id' ; value: 'mainContent'.! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 14:27'!
main
	"describes the main part of the body - related to css may be we should change that but 
	menu should be out and block and section nested in."
	
	^ main! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 21:52'!
metaHead

	^ '<?xml version="1.0" encoding="ISO-8859-1"?>
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">'! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:45'!
name 
	"For example the welcomePage can be called Home "
	^ name! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:40'!
name: aString
	name := aString! !

!KZPage methodsFor: 'printing' stamp: 'sd 1/8/2012 21:04'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	aStream nextPutAll: self name. ! !

!KZPage methodsFor: 'accessing' stamp: 'sd 1/6/2012 22:19'!
site

	^ site! !

!KZPage methodsFor: 'accessing' stamp: 'sd 1/6/2012 22:20'!
site:  aSite

	site := aSite! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:41'!
title

	^ title ! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:40'!
title: aString

	title := aString! !

Object subclass: #KZSite
	instanceVariableNames: 'elements pages folder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZSite methodsFor: 'initialize' stamp: 'sd 1/6/2012 22:03'!
addPage: aPage

	pages add: aPage! !

!KZSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/18/2012 21:19'!
declare: anElement withId: anID
	"Declare the element with a given id so that we can link back to it"
	
	elements at: anID put: anElement! !

!KZSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/18/2012 21:20'!
declarePage: aPage withId: anID
	"Declare a page with a given id for future reference. A page is also added to the site web page."
	elements at: anID put: aPage.
	aPage site: self.
	pages add: aPage.! !

!KZSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/19/2012 21:29'!
generate
	"self new generate"
	
	| visitor |
	visitor := self visitorClass new.
	visitor visitSite: self site.
	! !

!KZSite methodsFor: 'initialize' stamp: 'sd 1/6/2012 22:02'!
initialize

	super initialize.
	elements := Dictionary new.
	pages := OrderedCollection new.! !

!KZSite methodsFor: 'operations' stamp: 'sd 1/6/2012 22:25'!
pages
	^ pages! !

!KZSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/19/2012 21:29'!
visitorClass

	^  KZVisitor ! !

KZSite subclass: #KzMenuInfoBodySite
	instanceVariableNames: 'bibBuilder cssDirectoryName cssFilename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KzMenuInfoBodySite class methodsFor: 'initialization' stamp: 'StephaneDucasse 2/5/2012 16:26'!
defaultCSS

 	^ 'body{
	COLOR: #000000; 
	BACKGROUND: #FFFFFF;                                    
	
	font: 10pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;

	PADDING-LEFT: 0px;
	PADDING-RIGHT: 0px;
	PADDING-TOP: 0px;
	PADDING-BOTTOM: 0px;
}


/* HEADER */

#header {
}

#headerSiteTitle {
	font-size: 12pt;
	font-weight: 500;
	letter-spacing: 1px;
	border-bottom: 1px solid #CCCCCC;
	width: 128px;
}


#headerSiteTitle {
	font-size: 12pt;
	font-weight: 500;
	letter-spacing: 1px;
	border-bottom: 1px solid #CCCCCC;
	width: 250px;
}

#headerPageTitle {
	font-size: 10pt;
	font-weight: 500;
	color: #777777;
	letter-spacing: 7px;
	margin-left: 8px;
	padding-left: 48px;
	border-left: 1px solid #CCCCCC
}

/* HEADER - end*/

/* MENU */


#menu {
	float: left;

	margin-left: 8px;
	margin-right: 32px;
	margin-bottom: 16px;
	width: 142px;
}


#toc {
	font-size: 8pt;
	padding-top: 16px;
	border-left: 1px solid #CCCCCC;
}


#tocItem {
	padding: 8px;
	border-bottom: 1px #CCCCCC solid;
}

#copyright {
	font: 7pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;
	color: #777777;
	margin-top: 8px;
	margin-bottom: 8px;
}

/*MENU - end*/

/*MAIN*/

td{
	font: 8pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;
}


#mainContent {
	position: absolute;
	left: 160px;
	margin: 8px;
	margin-top: 0px;
	padding-top: 16px;
	
	font: 9pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;
	
}

#personalDetails {
	font: 7pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;
	float: right;
	width: 128px;
	margin-left: 16px;
	margin-bottom: 16px;
}

#personalDetailsItem{
	margin-left: 8px;
	border-left: 1px solid #CCCCCC;
	border-bottom: 1px solid #CCCCCC;
	padding: 8px;
}

/*MAIN - end*/

/*COMMON*/

#commonList {
}

#commonItem {
	padding-top: 8px;
	padding-bottom: 8px;
}

#commonItemDate {
	font-size: 7pt;
}

#commonItemDate:before {
	content: " ("
}

#commonItemDate:after {
	content: ") "
}

#commonItemTitle {
}

#commonItemDescription {
}

#commonItemDescription:before {
	content: "-"
}

#commonItemDetail {
	font-size: 7pt;
	margin-left: 16px;
}

/*COMMON - end*/


/*PUBLICATIONS*/

.paperList, .projectList, .contactData {
	padding-bottom:32px;
}

.paperListTitle, .projectListTitle, .contactTitle {
	letter-spacing: 2px;
	border-bottom: 1px solid #CCCCCC;
	margin-bottom: 16px;
}

.paper, .project, .supervisedThesis, .presentation {
	padding-bottom: 16px;
}

.paperAbstract, .paperBibEntry, .thesisSupervisor, .thesisAbstract {
	font-size: 7pt;
	margin-left: 16px;
	margin-top: 4px;
}

.paperRef, .thesisRef {
	margin-left: 16px;
	margin-top: 4px;
}

.paperDate, .thesisDate, .projectDate, .presentationDate {
	font-size: 7pt;
}

.paperDate:before, .thesisDate:before, .projectDate:before, .presentationDate:before {
	content: " ("
}

.paperDate:after, .thesisDate:after, .projectDate:after, .presentationDate:after {
	content: ") "
}


.paperDescription:before, .thesisDescription:before, .projectDescription:before, .presentationLocation:before {
	content: "- "
}

.paperAuthor:after, .thesisAuthor:after {
	content: " - "
}

.paperTitle, .thesisTitle {	
	color: #992222;
}

.paperTitle:after, .paperTitle:before, .thesisTitle:after, .thesisTitle:before {
	content: "''"
}

.emphasize {
	font-weight: bold;
}

.lineHeader {
	font-weight: bold;
}

/*PUBLICATIONS - end*/




/*DOCBOOK*/

#docbook {
/*	font: 9pt Times New Roman, Verdana, Tahoma, Arial, Helvetica, sans-serif;*/
}

.revhistory {
	display: none;
}

h2 {
	font-size: 12pt;
	font-weight: 200;
	letter-spacing: 2px;
}

h3 {
	font-size: 10pt;
	font-weight: 200;
	letter-spacing: 2px;
}

hr {
	display: none;
}

/*DOCBOOK - end*/


/* LINKS */

A:link {
	COLOR: #000099;
	TEXT-DECORATION: none;
}

A:visited {
	COLOR: #000099;
	TEXT-DECORATION: none;
}

A:hover {
	COLOR: #883333;
	TEXT-DECORATION: none;
}

A:active {
	COLOR: blue;
	TEXT-DECORATION: none;
}
'! !

!KzMenuInfoBodySite class methodsFor: 'initialization' stamp: 'StephaneDucasse 1/18/2012 21:25'!
generate
	"self generate"
	self new generate! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 08:14'!
block
	| block |
	block := KZRightBlock new.
	self buildBlockBodyOn: block.
	self declare: block withId: #block.
	^ block! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: 'StephaneDucasse 1/18/2012 21:08'!
buildBlockBodyOn: block
	block addElement: self imageItem.
	block addElement: self inriaBlockItem.
	block addElement: self rmodBlockItem.
	block addElement: self mailToBlockItem! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/18/2012 21:05'!
buildMenuBodyOn: menu
	"Subclasses can change the menu items simply by changing this method"

	menu addElement: self homeMenuItem.
	menu addElement: self pharoMenuItem.
	menu addElement: self coordinatesMenuItem! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 21:24'!
buildOtherPages

	! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/23/2012 14:13'!
buildWelcomePageSectionsOn: welcomePage
	welcomePage addElementInMain: self sectionCurrentJob.
	welcomePage addElementInMain: self sectionNews.	
	! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/24/2012 09:28'!
coordinatesBody

	| section | 
	section := KZSection new title: 'Snail Mail' ; text: self coordinatesText.
	self declare: section withId: #secCoordinates.
	^ section! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/24/2012 09:27'!
coordinatesFileName.
	^ 'Coordinates'! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: 'StephaneDucasse 1/24/2012 09:19'!
coordinatesMenuItem
	^ KZMenuItem new
		name: 'Coordinates';
		link: self coordinatesFileName, '.html';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/24/2012 09:20'!
coordinatesName
	"Returns the title of the coordinates page"
	
	^ 'Coordinates'! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/24/2012 09:25'!
coordinatesPage
	| coordinatePage |
	coordinatePage := KZPage name: self coordinatesName filename: self coordinatesFileName.
	self declarePage: coordinatePage withId: #coordinatesPage.
	coordinatePage addElement: self menu.
	coordinatePage addElementInMain: self block.
	coordinatePage addElementInMain: self coordinatesBody.
	^ coordinatePage! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/24/2012 09:34'!
coordinatesText

	^ 'Pay attention my snail mail address is not where my office is. If you want to 
	visit me <A href="http://rmod.lille.inria.fr/">check that page</a>.
	
	Pay attention that you really put INRIA in the address. 
	
	<p>Address: <br>
		INRIA - S. Ducasse, 40, avenue Halley, <br>
		Parc Scientifique de la Haute Borne, <br>
		Bat.A, Park Plaza <br
		Villeneuve d''Ascq  59650 <br>
		France <br>
		Tel:33 (0)3 20 43 42 56<br>
		Fax:33 (0)3 59 57 78 50<br>
    </p>'
! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: 'StephaneDucasse 2/5/2012 16:24'!
cssDirectoryName
	^ cssDirectoryName! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: 'StephaneDucasse 2/5/2012 16:24'!
cssDirectoryName: aString
	cssDirectoryName := aString! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 2/5/2012 16:22'!
cssFile
	^ self cssDirectoryName, self cssFilename! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: 'StephaneDucasse 2/5/2012 16:23'!
cssFilename

	^ cssFilename! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: 'StephaneDucasse 2/5/2012 16:24'!
cssFilename: aString
	cssFilename := aString! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/19/2012 09:02'!
currentJobText

	^ 'I''m ZZZ and I have a lot of fun doing KKK .' ! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 09:34'!
currentSectionTitle
	^ 'Current Situation'! !

!KzMenuInfoBodySite methodsFor: 'operations' stamp: 'StephaneDucasse 1/24/2012 09:12'!
declarePage: aPage withId: aSymbol

	super declarePage: aPage withId: aSymbol.
	self defineInformationOfPage: aPage.
	! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 21:57'!
defineInformationOfPage: welcomePage
	welcomePage title: self title.
	welcomePage cssFile: self cssFile.
	welcomePage headerSiteTitle: self headerSiteTitle.
	! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 2/5/2012 17:01'!
generate
	"Generate the directory for the CSS and the default CSS."
	self installCSS.
	super generate.! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/19/2012 21:57'!
headerSiteTitle

	^ 'Ze great title'
	! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 08:13'!
homeMenuItem
	^ KZMenuItem new
		name: 'Home';
		link: 'index.html';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: 'StephaneDucasse 1/18/2012 21:32'!
imageItem
	^ KZImage new
		image: self imageName;
		yourself! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/18/2012 21:18'!
imageName
	^ 'PictureToBeDisplayedIn128Pixels.jpg'! !

!KzMenuInfoBodySite methodsFor: 'initialize' stamp: 'StephaneDucasse 2/5/2012 16:38'!
initialize
	super initialize.
	self cssFilename: 'CSS'.
	self cssDirectoryName: 'CSS.css'.
	! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: 'StephaneDucasse 1/19/2012 08:16'!
inriaBlockItem
	^ KZBlockItem new
		name: 'INRIA';
		link: 'http://www.inria.fr/';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'initialize' stamp: 'StephaneDucasse 2/5/2012 17:00'!
installCSS

	| wk |
	wk := FSFilesystem disk workingDirectory.
	(wk / self cssDirectoryName) ensureDirectory.
	(wk / self cssDirectoryName / self cssFilename) writeStreamDo: 
		[:st | st nextPutAll: self class defaultCSS ]! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/18/2012 21:12'!
mailText
	^ 'XXXX(@At@)YYYY.HHH'! !

!KzMenuInfoBodySite methodsFor: 'mail' stamp: 'StephaneDucasse 1/19/2012 08:13'!
mailToBlockItem
	^ KZBlockItem new
		name: self mailText;
		link: self mailtoString;
		yourself! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/18/2012 21:13'!
mailtoString
	^ 'mailto:real.address@foo.bar'! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 08:15'!
menu
	| menu |
	menu := KZMenu new.
	self buildMenuBodyOn: menu.
	self declare: menu withId: #menu.
	^ menu! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 09:37'!
newsSectionTitle
	^ 'News'! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 09:39'!
newsText

	^ '<div class="itemizedlist"> 
      <ul type="disc"> 
		<li>I attended <a href="http://www.esug.org/wiki/pier/Conferences/2011"> ESUG 2011</a>. </li>
	 	<li><a href="http://www.pharo-project.org/">Pharo</a> is cool!!</li>
	
	  </ul>
    </div>'! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 08:13'!
pharoMenuItem
	^ KZMenuItem new
		name: 'Pharo';
		link: 'http://www.pharo-project.org';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: 'StephaneDucasse 1/19/2012 08:16'!
rmodBlockItem
	^ KZBlockItem new
		name: 'RMOD';
		link: 'http://rmod.lille.inria.fr/';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 09:34'!
sectionCurrentJob
	| section |
	section := KZSection new
		title: self currentSectionTitle;
		text: self currentJobText.
	self declare: section withId: #secCurrentJob.
	^ section! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 09:37'!
sectionNews
	| section |
	section := KZSection new
		title: self newsSectionTitle;
		text: self newsText.
	self declare: section withId: #secNews.
	^ section! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/24/2012 09:27'!
site
	"self site"
	
	self createResearchSubTopicPages.
	self welcomePage.
	self coordinatesPage.
	self buildOtherPages.
	
	^ self.
	! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/19/2012 21:47'!
title 

	^ 'Dr. St&eacute;phane Ducasse' ! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 21:24'!
welcomeName
	^ 'Home'! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/24/2012 09:12'!
welcomePage
	| welcomePage |
	welcomePage := KZPage  name: self welcomeName filename: 'index'.
	self declarePage: welcomePage withId: #welcomePage.
	welcomePage addElement: self menu.
	welcomePage addElementInMain: self block.
	self buildWelcomePageSectionsOn: welcomePage.
	^ welcomePage! !

Object subclass: #KZVisitor
	instanceVariableNames: 'site stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZVisitor commentStamp: 'StephaneDucasse 1/1/2012 22:52' prior: 0!
ARVisitor is a web site visitor. !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:19'!
addComment: aComment
	stream 
		nextPutAll: '    <!!--'; 
		nextPutAll: aComment; 
		nextPutAll: ' -->'.
	! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:12'!
bodyEncodings
	^ 'body'! !

!KZVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/2/2012 22:19'!
contents

	^ stream contents! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:38'!
cr

	stream nextPut: Character cr! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:31'!
div

	self startBalise: 'div'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:12'!
divEncodings
	^ 'div'! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:37'!
endBalise: aString

	stream nextPut: $< ; nextPut: $/.
	stream nextPutAll: aString.
	stream nextPut: $>. 
	

	! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:38'!
endBaliseCr: aString

	self endBalise: aString.
	self cr.
	

	! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
endBody

	self endBalise: 'body'.! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:32'!
endDiv

	self endBalise: 'div'! !

!KZVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:12'!
ensureAttribute: aKey value: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: aKey value: aTag.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	self cr! !

!KZVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:13'!
ensureBody: aBlock
	self startBalise: self bodyEncodings.
	aBlock cull: stream.
	self endBalise: self bodyEncodings! !

!KZVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/3/2012 11:25'!
ensureDiv: aBlock
	
	self div.
	aBlock value: stream.
	self endDiv! !

!KZVisitor methodsFor: 'operation' stamp: 'sd 1/7/2012 16:36'!
ensureIdValue: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: 'id' value: aTag.
	self cr.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:31'!
ensureTag: aString for: aBlock

	self startBalise: aString.
	aBlock value: stream.
	self endBalise: aString! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
headerEncodings
	^ 'header'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:15'!
headerPageTitleEncodings
	^ 'headerPageTitle'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
headerSideTitleEncodings
	^ 'headerSideTitle'! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/6/2012 14:36'!
href: url name: aString

	stream 
		nextPutAll: '<a href="';
		nextPutAll: url;
		nextPutAll: '">';
		nextPutAll: aString;
		nextPutAll: '</a>'! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:18'!
mainContentEncodings
	^ 'mainContent'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:13'!
menuEncodings
	^ 'menu'! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/6/2012 21:57'!
newFileFor: aPage
	^ FileStream forceNewFileNamed: aPage filename! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:15'!
personalDetailsEncodings
	^ 'personalDetails'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 14:57'!
personalDetailsItemEncodings
	^ 'personalDetailsItem'! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
startBalise: aString

	stream nextPut: $<.
	stream nextPutAll: aString.
	stream nextPut: $>.
	stream nextPut: Character cr.

	! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 22:38'!
startBalise:  balise attribute: aKey value: aTag.
	
	stream 
		nextPut: $<; 
		nextPutAll: balise ; 
		nextPut: Character space ; 
		nextPutAll: aKey ; 
		nextPutAll: '="' ; 
		nextPutAll: aTag; 
		nextPutAll: '">'.! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
startBody

	self startBalise: 'body'.! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:13'!
tocEncodings
	^ 'toc'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
tocItemEncodings
	^ 'tocItem'! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/2/2012 22:47'!
visit: anElement

	anElement accept: self! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/18/2012 21:36'!
visitBibItemCollection: aBibItemCollection
	
	self ensureTag: 'ol' for: [:aStream | 
		KZBibHTMLOutputer  new 
			treatEntries: aBibItemCollection elements in: aStream]
		! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:18'!
visitDivBlock: aBlock

	self
		ensureIdValue: self mainContentEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/6/2012 14:39'!
visitImage: aLinkedImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<img src="'; nextPutAll: aLinkedImage image; 
				nextPutAll: '">' ; 
				nextPut: Character cr]! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/8/2012 22:51'!
visitItem: anItem

	self ensureTag: 'li' for: [:aStream | aStream nextPutAll: '<a href="', anItem link, '">', anItem name].
	stream cr.! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/8/2012 22:39'!
visitItemList: aList

	self ensureAttribute: 'class'
			 value: 'itemizedlist'
			 div: [
				self ensureTag: 'ul' for: 
					[ :aStream | aList elements do: [:each | self visit: each ] ] ]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/6/2012 09:51'!
visitLinkedImage: anImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<a href="'; 
				nextPutAll: anImage link; 
				nextPutAll: '"><img src="'; nextPutAll: anImage image; 
				nextPutAll: '"></a>' ; 
				nextPut: Character cr]! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/7/2012 16:53'!
visitMenu: aMenu
	self
		ensureIdValue: self menuEncodings
		div: [ 
			self
				ensureIdValue: self tocEncodings
				div: [ aMenu elements do: [ :each | self visit: each ] 
										separatedBy: [ stream cr ] ] ]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:11'!
visitMenuItem: aMenuItem
	self ensureIdValue: self tocItemEncodings div: [ self href: aMenuItem link name: aMenuItem name ]! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/8/2012 21:26'!
visitPage: aPage
	
	[stream := self newFileFor: aPage.
	stream nextPutAll: aPage metaHead.
	stream nextPutAll: aPage head.
	self
		ensureBody: [ 
			self
				ensureIdValue: self headerEncodings
				div: [ 
					self ensureIdValue: self headerSideTitleEncodings div: [ stream nextPutAll: aPage headerSiteTitle ].
					self ensureIdValue: self headerPageTitleEncodings div: [ stream nextPutAll: aPage headerPageTitle ]].
			aPage elements do: [ :each | self visit: each ].
			self ensureIdValue: self mainContentEncodings div: [ 
					aPage main elements do: [ :each | self visit: each ]]			
			]]
		ensure: [stream close]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:12'!
visitRightBlock: aBlock
	self
		ensureIdValue: self personalDetailsEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:12'!
visitRightBlockItem: anItem
	self ensureIdValue: self personalDetailsItemEncodings div: [ self href: anItem link name: anItem name ]! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/7/2012 20:55'!
visitSection: aSection

	stream nextPutAll:  '<h', aSection levelDigitString,'><b><a NAME="', aSection title, '">',  aSection title, '</a></b></h', aSection levelDigitString,'>'.
	stream nextPutAll:  aSection text.! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/6/2012 22:15'!
visitSite: aSite

	aSite pages do: [:each | self visit: each].! !
